## net.sf.saxon.tinytree
Class TinyBuilder

    java.lang.Object
      net.sf.saxon.event.Builder
          net.sf.saxon.tinytree.TinyBuilder

All Implemented Interfaces:
  javax.xml.transform.Result, Receiver

    public class TinyBuilder

extends Builder

The TinyBuilder class is responsible for taking a stream of SAX events and constructing a Document tree, using the "TinyTree" implementation.

Author:
  Michael H. Kay

Field Summary
`static int` `PARENT_POINTER_INTERVAL`

Fields inherited from class net.sf.saxon.event.Builder
`baseURI, config, currentRoot, lineNumbering, LINKED_TREE, namePool, pipe, STANDARD_TREE, started, systemId, timing, TINY_TREE, UNSPECIFIED_TREE_MODEL`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`TinyBuilder()` Create a TinyTree builder

Method Summary
`void` `attribute(int nameCode, int typeCode, java.lang.CharSequence value, int locationId, int properties)` Notify an attribute.
`void` `characters(java.lang.CharSequence chars, int locationId, int properties)` Callback interface for SAX: not for application use
`void` `close()` Notify the end of the event stream
`void` `comment(java.lang.CharSequence chars, int locationId, int properties)` Callback interface for SAX: not for application use
`void` `endDocument()` Callback interface for SAX: not for application use
`void` `endElement()` Callback interface for SAX: not for application use
`NodeInfo` `getLastCompletedElement()` Get the last completed element node.
`int[]` `getSizeParameters()` Get the size parameters for the tree
`TinyTree` `getTree()` Get the tree being built by this builder
`void` `namespace(int namespaceCode, int properties)` Notify a namespace.
`void` `open()` Open the event stream
`void` `processingInstruction(java.lang.String piname, java.lang.CharSequence remainder, int locationId, int properties)` Callback interface for SAX: not for application use
`void` `reset()` Reset the builder to its initial state.
`void` `setSizeParameters(int[] params)` Set the size parameters for the tree
`void` `setUnparsedEntity(java.lang.String name, java.lang.String uri, java.lang.String publicId)` Set an unparsed entity in the document
`void` `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` `startDocument(int properties)` Write a document node to the tree
`void` `startElement(int nameCode, int typeCode, int locationId, int properties)` Notify the start tag of an element

Methods inherited from class net.sf.saxon.event.Builder
`build, build, getBaseURI, getConfiguration, getCurrentRoot, getPipelineConfiguration, getSystemId, isTiming, setBaseURI, setLineNumbering, setPipelineConfiguration, setSystemId, setTiming`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### PARENT_POINTER_INTERVAL

    public static final int PARENT_POINTER_INTERVAL

See Also:
  Constant Field Values

Constructor Detail

### TinyBuilder

    public TinyBuilder()

  Create a TinyTree builder

Method Detail

### setSizeParameters

    public void setSizeParameters(int[] params)

  Set the size parameters for the tree

  Parameters:
    `params` - an array of four integers giving the expected number of non-attribute nodes, the expected number of attributes, the expected number of namespace declarations, and the expected total length of character data

### getSizeParameters

    public int[] getSizeParameters()

  Get the size parameters for the tree

  Returns:
    an array of four integers giving the actual number of non-attribute nodes, the actual number of attributes, the actual number of namespace declarations, and the actual total length of character data

### getTree

    public TinyTree getTree()

  Get the tree being built by this builder

  Returns:
    the TinyTree

### open

    public void open()
              throws XPathException

  Open the event stream

  Specified by:
    `open` in interface `Receiver`
  Overrides:
    `open` in class `Builder`
  Throws:
    `XPathException`

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Write a document node to the tree

  Specified by:
    `startDocument` in interface `Receiver`
  Overrides:
    `startDocument` in class `Builder`
  Parameters:
    `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException`

### endDocument

    public void endDocument()
                     throws XPathException

  Callback interface for SAX: not for application use

  Specified by:
    `endDocument` in interface `Receiver`
  Overrides:
    `endDocument` in class `Builder`
  Throws:
    `XPathException`

### reset

    public void reset()

  Description copied from class: `Builder`
  Reset the builder to its initial state. The most important effect of calling this method (implemented in subclasses) is to release any links to the constructed document tree, allowing the memory occupied by the tree to released by the garbage collector even if the Builder is still in memory. This can happen because the Builder is referenced from a parser in the Configuration's parser pool.

  Overrides:
    `reset` in class `Builder`

### close

    public void close()
               throws XPathException

  Description copied from interface: `Receiver`
  Notify the end of the event stream

  Specified by:
    `close` in interface `Receiver`
  Overrides:
    `close` in class `Builder`
  Throws:
    `XPathException`

### startElement

    public void startElement(int nameCode,
                             int typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Notify the start tag of an element

  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool. The value -1 indicates the default type, xs:untyped.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - bit-significant properties of the element node. If there are no revelant properties, zero is supplied. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException`

### namespace

    public void namespace(int namespaceCode,
                          int properties)
                   throws XPathException

  Description copied from interface: `Receiver`
  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element. The events represent namespace declarations and undeclarations rather than in-scope namespace nodes: an undeclaration is represented by a namespace code of zero. If the sequence of namespace events contains two A namespace must not conflict with any namespaces already used for element or attribute names.

  Parameters:
    `namespaceCode` - an integer: the top half is a prefix code, the bottom half a URI code. These may be translated into an actual prefix and URI using the name pool. A prefix code of zero represents the empty prefix (that is, the default namespace). A URI code of zero represents a URI of "", that is, a namespace undeclaration.
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error: it sets the REJECT_DUPLICATES flag, and this is treated as a hard error.
  Throws:
    `XPathException`

### attribute

    public void attribute(int nameCode,
                          int typeCode,
                          java.lang.CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Description copied from interface: `Receiver`
  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool. The additional bit NodeInfo.IS_DTD_TYPE may be set to indicate a DTD-derived type.
    `value` - the string value of the attribute
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
  Throws:
    `XPathException`

### startContent

    public void startContent()

  Description copied from interface: `Receiver`
  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

### endElement

    public void endElement()
                    throws XPathException

  Callback interface for SAX: not for application use

  Throws:
    `XPathException`

### getLastCompletedElement

    public NodeInfo getLastCompletedElement()

  Get the last completed element node. This is used during checking of schema assertions, which happens while the tree is still under construction. This method is called immediately after a call on endElement(), and it returns the element that has just ended.

  Returns:
    the last completed element node, that is, the element whose endElement event is the most recent endElement event to be reported

### characters

    public void characters(java.lang.CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Callback interface for SAX: not for application use

  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  Throws:
    `XPathException`

### processingInstruction

    public void processingInstruction(java.lang.String piname,
                                      java.lang.CharSequence remainder,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Callback interface for SAX: not for application use

  Parameters:
    `piname` - The PI name. This must be a legal name (it will not be checked).
    `remainder` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI. The following bits are defined:
  CHECKED
    Data is known to be legal (e.g. doesn't contain "?>")
  Throws:
    `XPathException`

### comment

    public void comment(java.lang.CharSequence chars,
                        int locationId,
                        int properties)
                 throws XPathException

  Callback interface for SAX: not for application use

  Parameters:
    `chars` - The content of the comment
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment. The following bits are defined:
  CHECKED
    Comment is known to be legal (e.g. doesn't contain "--")
  Throws:
    `XPathException`

### setUnparsedEntity

    public void setUnparsedEntity(java.lang.String name,
                                  java.lang.String uri,
                                  java.lang.String publicId)

  Set an unparsed entity in the document

  Parameters:
    `name` - The name of the unparsed entity
    `uri` - The system identifier of the unparsed entity
    `publicId` - The public identifier of the unparsed entity

Copyright (c) Saxonica Limited. All rights reserved.